m16projectileHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false},
}

function rndFloat(mi, ma)
	return mi + (ma-mi)*(math.random(0, 1000000)/1000000.0)
end

function notZero(num)
	if num == 0 then return 0.001 end
end

function isItemInTable(item,listing) --for duplicate bodys in tables
	local listed = false
	
	for i,k in ipairs(listing) do
		if k == item then listed = true end --found
	end
	
	if listed then return true else return false end
end


function init()
	RegisterTool("m16a1", "M16A1", "MOD/vox/m16a1.vox",3)
	SetBool("game.tool.m16a1.enabled", true)
	SetFloat("game.tool.m16a1.ammo", 12000)

	damage = 0.556
	gravity = Vec(0, -9.81, 0)
	bulletVelocity = 690

	gunsound = LoadSound("tools/gun1.ogg")
	dryfiresound = LoadSound("MOD/snd/dryfire.ogg")
	stunfiresound = LoadSound("error.ogg")
	boltactionsound = LoadSound("MOD/snd/awp_cock.ogg")
	akcocksound = LoadSound("MOD/snd/ak_cock.ogg")
	sparksound = LoadSound("light/spark1.ogg")
	sparksound2 = LoadSound("light/spark2.ogg")
	sparksound3 = LoadSound("light/spark0.ogg")

	reloadTime = 1.2
	shotDelay = 0.063
	spreadTimer = 0
	maxSpread = 1
	ammo = 240
	
	moreAmmo = GetBool("savegame.mod.moreammo")
	if moreAmmo then
	ammo = 420
	end
	
	stun = false
	lefthand = false
	lefthandKey = "B"
	crouched = false

	unlimitedammo = GetBool("savegame.mod.unlimitedammo")

	for i=1, 55 do
		m16projectileHandler.shells[i] = deepcopy(m16projectileHandler.defaultShell)
	end
	
	shootTimer = 0
	reloadTimer = 0
	recoilTimer = 0
	recoilDelay = 0.25
	lightTimer = 0
	
	--spread operators
	spreadDegree = 0 --how much spread angle to be in the next shot
	spreadAim = Quat() --persistent angle of spread for shooting
	maxSpreadAngle = 6.15
	spreadDecrease = 4.2
	spreadIncrease = 0.17
	fsSpreadIncrease = 1.3 --first shot spread multiplier
	spreadH = 0 --the horizontal degree of the shot spread
	spreadV = 0 --ditto vertical
	
	--recoil operators
	vrec = 0
	vrecamount = 0.54
	hrec = 0
	vpunch = 0.0
	vpunchamt = 3
	vpunchtarget = 0
	firstshot = true
	fsrm = 2.52
	
	--recoil anims
	animT = Transform()
	kickback = 0
	kickbackTarget = 0.3
	kickbackMax = 0.2
	moveback = 0 --average full auto impulse
	kickup = 0
	kickupTarget = 13
	kicktilt = 0
	kickupCompensate = 0
end

function canShoot() --no shooting in the car
	local vehicle = GetPlayerVehicle()
	if vehicle ~= 0 then
		local driverPos = GetVehicleDriverPos(vehicle)
		local t = GetVehicleTransform(vehicle)
		local worldPos = TransformToParentPoint(t, driverPos)
		local cameraPos = GetCameraTransform().pos
		local length = VecLength(VecSub(cameraPos, worldPos))

		if length < 1 then
			return true
		else
			return false
		end
	end
	return true
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos(quat) --where your crosshair is
	local ct = GetCameraTransform()
	ct.rot = QuatRotateQuat(ct.rot,quat)
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function muzzleFlash() --set up the muzzleflash particle
	ParticleReset()
	ParticleType("plain")
	ParticleTile(0)
	ParticleColor(0.8,0.65,0.5)
	ParticleRadius(0.15,0.05)
	ParticleAlpha(1,1,"constant")
	ParticleEmissive(2,0.3)
	ParticleStretch(1)
	ParticleSticky(0)
	ParticleCollide(0)
end

function Shoot()
	if shootTimer > 0 or ammo == 0 then
		return
	end
	local shakeamt = 0.44
	
	aimpos, hit, distance = GetAimPos(aimShiftQuat)
	local toolBody = GetBodyTransform(GetToolBody())
	local start = 2.1
	local height = 0.275
	gunpos = TransformToParentPoint(toolBody, Vec(0.225, -height, -start))
	bulletstart = TransformToParentPoint(toolBody, Vec(0.23, -height, -start))
	--local bulletdir = Transform(bulletstart,toolBody.rot)

	local p = bulletstart
	if nearWall then p = GetPlayerCameraTransform().pos end
	local muzzletrans = Transform(p,QuatLookAt(p,VecAdd(p,TransformToParentVec(toolBody,Vec(0,0,-1)))))
	local dir = VecSub(aimpos, p)
	local dist = VecLength(dir)
	local dirtrans = Transform(Vec(),QuatLookAt(Vec(),dir))
	
	--spread operation
	-- local dirOrig = TransformCopy(dirtrans) --copy original direction rot
	-- dirtrans.rot = QuatRotateQuat(dirtrans.rot,spreadAim)
	-- dir = TransformToParentVec(dirtrans,Vec(0,0,-VecLength(dir)))
	spreadCircleVec = VecNormalize(Vec(rndFloat(-1,1),rndFloat(-1,1))) --x and y
	spreadCircleVec = VecScale(spreadCircleVec,math.tan(math.rad(rndFloat(-spreadDegree,spreadDegree)))*dist)
	spreadCircleVec = VecAdd(Vec(0,0,-dist),spreadCircleVec)
	
	dir = TransformToParentPoint(dirtrans,spreadCircleVec)


	m16projectileHandler.shells[m16projectileHandler.shellNum] = deepcopy(m16projectileHandler.defaultShell)
	loadedShell = m16projectileHandler.shells[m16projectileHandler.shellNum] 
	loadedShell.active = true
	loadedShell.pos = p
	--loadedShell.predictedBulletVelocity = VecScale(dir,(bulletVelocity))
	loadedShell.predictedBulletVelocity = VecScale(dir,(bulletVelocity/distance))
	loadedShell.dist = 0
	loadedShell.renderdist = 12
	loadedShell.rendering = false
	loadedShell.killdist = 900
	if stun then
		loadedShell.stun = true
		shakeamt = 0.3
	else
		loadedShell.stun = false --set fire if true
	end
	m16projectileHandler.shellNum = (m16projectileHandler.shellNum%#m16projectileHandler.shells) + 1

	muzzleFlash()
	if stun then ParticleColor(0.5,0.65,0.8) end
	bulletstart = VecAdd(bulletstart,verletVel)
	SpawnParticle(bulletstart,TransformToParentVec(muzzletrans,Vec(0,0,-10)),0.05)
	SpawnParticle(bulletstart,TransformToParentVec(muzzletrans,Vec(0,10,0)),0.03)
	SpawnParticle(bulletstart,TransformToParentVec(muzzletrans,Vec(-5,-5,0)),0.03)
	SpawnParticle(bulletstart,TransformToParentVec(muzzletrans,Vec(5,-5,0)),0.03)
	local hearable = true
	if stun then hearable = false end --if stun mode, nothing will pick up the gunshot
	if not stun then PlaySound(gunsound, GetPlayerTransform().pos, 4.34, hearable)
	else PlaySound(gunsound, GetPlayerTransform().pos, 0.4, hearable) end

	--recoil operation

	hrec = hrec + rndFloat(-0.35,0.8)
	hrec = math.min(hrec,2)
	hrec = math.max(hrec,-2)
	
	local finalvrec = vrecamount
	if firstshot then 
		finalvrec = vrecamount * fsrm
		kickup = kickupTarget
		firstshot = false
	else
		kickup = math.max(kickup,kickupTarget/1.6)
	end
	
	--recoil anims
	vrec = math.min(6,vrec + vrecamount)
	kickback = kickbackTarget
	if moveback <= 0.03 then
		moveback = moveback + 0.03/6
	end
	kicktilt = kicktilt + math.random(-2,10)
	
	if crouched then kickbackMax = 0.15 else kickbackMax = 0.2 end

	ShakeCamera(shakeamt)

	if not unlimitedammo then
		ammo = ammo - 1
	end
	--DebugPrint(spreadTimer)
	shootTimer = shotDelay
	recoilTimer = recoilDelay
	lightTimer = shotDelay/2
	vpunchtarget = vpunchamt
	
	local finalspreadinc = spreadIncrease
	if spreadDegree < 0.6 then
		spreadDegree = fsSpreadIncrease
	else
		spreadDegree = math.min(spreadDegree+finalspreadinc+spreadDecrease*shotDelay,maxSpreadAngle)
	end

end--]]

function ProjectileOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	--projectile.predictedBulletVelocity[2] = projectile.predictedBulletVelocity[2]-9.8*GetTimeStep()
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	
	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		projectile.active = false
		local destructiblerobotsdmg = 11
		local destructiblerobotsstun = 1.5
		if projectile.stun then
			MakeHole(hitPos, 0.07, 0.07, 0) --turns out hard metal is used for tank armour
			PointLight(hitPos,0.1,0.3,1, 1.6)
			PlaySound(sparkrandomizer(),hitPos, 9, true)
			destructiblerobotsdmg = 1
			destructiblerobotsstun = 5
		else
			MakeHole(hitPos, damage, damage*0.8, 0,true)
			SpawnParticle("smoke", hitPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), damage, 1)
			SpawnParticle("smoke", hitPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), damage, 1)
			--holed body
			QueryRequire("physical") --dynamic optional
			local mi = VecAdd(hitPos,Vec(-0.11,-0.11,-0.11))
			local ma = VecAdd(hitPos,Vec(0.11,0.11,0.11))
			local bodies = QueryAabbBodies(mi, ma)	
			local hitbody = GetShapeBody(hitShape)
			--DebugPrint(isItemInTable(hitbody,bodies))
			if not isItemInTable(hitbody, bodies) then 
				table.insert(bodies, GetShapeBody(hitShape))
			end
			for i,body in ipairs(bodies) do
				--compute body center and dist
				local bmi,bma = GetBodyBounds(body)
				local bc = VecLerp(bmi,bma,0.5) --get center
				local dir = VecSub(bc, hitPos)
				local dist = VecLength(dir)
				dir = VecScale(dir,1/dist)
				local mass = GetBodyMass(body)--get mass
				
				--dir forward
				dir = VecLerp(dir,projectile.predictedBulletVelocity,0.8)
				dir = VecNormalize(dir)
				
				local massScale = 1 - math.min(mass/(750),1)
				local distScale = 1 - math.min(dist/1.3,1)
				local force = math.min(1790/2.2522,12*mass)
				--local force = (13*mass*massScale*distScale)
				local add = VecScale(dir,force)
				
				ApplyBodyImpulse(body,hitPos,add)
			end
		end	
		destructiblerobots(hitPos,destructiblerobotsdmg,destructiblerobotsstun)
	else
		if projectile.rendering then
			if projectile.stun then
				DrawLine(projectile.pos, point2,0.3,0.66,1)
			else
				DrawLine(projectile.pos, point2)
			end
		end
	end
	
	projectile.dist = projectile.dist + VecLength(VecSub(point2,projectile.pos))
	if projectile.dist > projectile.renderdist and not projectile.rendering then projectile.rendering = true end
	
	projectile.pos = point2
	if projectile.dist > projectile.killdist then projectile.active = false end
end

function destructiblerobots(pos,damage,hitcounter) --thanks dima
    local hit, point, n, shape = QueryClosestPoint(pos, 0.3)
	if HasTag(shape, "shapeHealth") then
		if tonumber(GetTagValue(shape,"shapeHealth"))-damage < 0 and not HasTag(shape, "body") then 
			RemoveTag(shape,"unbreakable")
		end
	end

    if hit then 
        SetFloat('level.destructible-bot.hitCounter',hitcounter)
        SetInt('level.destructible-bot.hitShape',shape)
        SetString('level.destructible-bot.weapon',"weapon-name")
        SetFloat('level.destructible-bot.damage',damage)
    end 
end

function sparkrandomizer() --randomizes spark sound
	local sparks = {sparksound,sparksound2,sparksound3}
	return sparks[math.random(#sparks)]
end

function tick(dt)
	if GetString("game.player.tool") == "m16a1" and canShoot() then
		if InputDown("usetool") and ammo > 0 and GetPlayerGrabBody() == 0 then
			if InputPressed("usetool") then
				firstshot = true
			end
			Shoot()
		end

		if InputPressed("usetool") then
			if ammo == 0 then
				PlaySound(dryfiresound, GetPlayerTransform().pos, 1, false)
			end
		end
		
		--if InputReleased("usetool") then
		--	spreadTimer = 0 --"microbursting"
		--end
		
		if InputPressed(lefthandKey) then
			lefthand = not lefthand
		end
		
		if InputPressed("C") then
			stun = not stun
		end
		
		--if InputReleased("usetool") and ammo > 0  then --the post firing smoke effect
			--SpawnParticle("darksmoke", gunpos, Vec(0, 1.0+math.random(1,10)*0.1, 0), 0.3, 0.5)
		--end
		local b = GetToolBody()
		if b ~= 0 then
			crouched = InputDown("crouch")
			local heightOffset = crouched and 0.15 or 0
			local handedness = lefthand and -0.45 or 0
			
			if crouched then
				handedness = lefthand and -0.4 or -0.05
			end
			
			local offset = Transform(Vec(handedness, heightOffset, 0))
			offset.rot = QuatRotateQuat(offset.rot,QuatEuler(0,spreadH,0))
			--local aimpos, aimhit, aimdist = GetAimPos()
			--offset.rot = QuatLookAt(GetBodyTransform(b).pos, aimpos) 
			local extrasway = 0.7*(spreadDegree/math.max(0.001,maxSpreadAngle))^(1/2)
			SetToolTransform(offset,0.3+extrasway)

			toolTrans = GetBodyTransform(b)
			
			local t = Transform()
			local kickupCompensate = math.asin(math.rad(kickup))*0.65
			local kicktiltCompensate = math.asin(math.rad(kicktilt))*0.275
			
			t.pos = Vec(handedness-kicktiltCompensate, heightOffset-kickupCompensate, math.min(kickbackMax,kickback) + moveback)
			t.rot = QuatEuler(kickup+vrec, spreadH, 0)
			t.rot = QuatRotateQuat(t.rot,QuatEuler(0,0,kicktilt))
			animT.pos = VecLerp(animT.pos,t.pos,math.min(31*dt,0.6))
			animT.rot = QuatSlerp(animT.rot,t.rot,math.min(18*dt,0.6))
			
			SetToolTransform(animT,0.4)
			
			toolPos = TransformToParentPoint(toolTrans, Vec(0.225, -0.275, -2.1))
			
			verletVel = VecScale(VecSub(toolPos,prevToolPos),0.99)
			prevToolPos = toolPos
			-- toolPos = VecAdd(toolPos,vel)
				
			if lightTimer > 0 then
				local p = TransformToParentPoint(GetBodyTransform(b), Vec(0.1, -0.45, -2))
				if stun then
					PointLight(p, 0.1, 0.3, 1, 0.5)
				else
					PointLight(p, 1, 1, 1, 0.5)
				end
			end
		end
		aimShiftQuat = QuatEuler(vrec,-hrec,0)

		SetCameraFov(GetInt("options.gfx.fov")+vpunch)
	end
	if shootTimer <= 0 then 
		vrec = math.max(vrec - 12*dt,0) 
		if moveback > 0 then
			moveback = moveback - moveback*6*dt
		end
	end

	shootTimer = math.max(0,shootTimer - dt)
	lightTimer = math.max(0,lightTimer - dt)
	recoilTimer = math.max(0,recoilTimer - recoilTimer*6*dt - dt)
	
	spreadDegree = math.max(0,spreadDegree - spreadDecrease*dt)
	
	if vpunch < vpunchtarget then vpunch = math.min(vpunchtarget,vpunch + 150*dt) else vpunch = vpunchtarget end
	vpunchtarget = math.max(0,vpunchtarget - vpunchtarget*15*dt)
	
	kickback = math.max(0,kickback - kickback*22*dt)
	kickup = math.max(0,kickup - kickup*27*dt-27*dt)
	SetValue("kicktilt",0,"bounce",0.32)
	SetValue("hrec",0,"bounce",0.6)
	
	if spreadH < 0 then
		spreadH = math.max(spreadH +spreadDecrease*dt,0)
	elseif spreadH > 0 then
		spreadH = math.min(spreadH - spreadDecrease*dt,0)
	end
	
	-- DebugPrint(spreadDegree)
	
	for key, shell in ipairs(m16projectileHandler.shells) do
		if shell.active then
			ProjectileOperations(shell)
		end
	end
end

function draw()
	if GetString("game.player.tool") == "m16a1" and GetPlayerVehicle() == 0 then
		UiPush()
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			if not unlimitedammo then
				if stun then
					UiPush()
						UiColor(0.5,0.6,1)
						UiText(ammo.." (Shock)")
					UiPop()
				else
					UiText(ammo)
				end
			else
				if stun then
					UiPush()
						UiColor(0.5,0.6,1)
						UiText("Shock")
					UiPop()
				end
			end
		UiPop()
		
		UiPush()
			nearWall = false
			UiAlign("center middle")
			local ct = GetPlayerCameraTransform()
			local aimpos,hit,dist = GetAimPos(aimShiftQuat) --aimpos can be shifted by a quat inserted into function
			local p = toolPos
			local x,y,dist = UiWorldToPixel(aimpos) --get aimpos location on screen
			
			local muzzleT = Transform(p,ct.rot) --muzzle pointing ahead
			local muzzleDir = TransformToParentVec(muzzleT,Vec(0,0,-1))
			local aimDir = VecNormalize(VecSub(aimpos,p)) --dir of the aimpos from gun muzzle
			local blocked = VecDot(aimDir,muzzleDir) < math.cos(math.rad(60))
			if blocked then 
				nearWall = true 
			else
				QueryRequire("large")
				local t = Transform(p,QuatLookAt(p,aimpos))
				local hit,neardist = QueryRaycast(t.pos,TransformToParentVec(t,Vec(0,0,-1)),3)
				if hit then
					local x,y,dist = UiWorldToPixel(VecAdd(t.pos,TransformToParentVec(t,Vec(0,0,-neardist))))
					UiPush()
					UiTranslate(x,y)
					UiColor(1,1,1,0.6)
					UiImage("ui/hud/crosshair-gun.png")
					UiPop()
				end
			end
			-- DebugPrint(nearWall)
			-- DebugCross(p)
			UiTranslate(x,y)
			UiScale(1+math.tan(math.rad(spreadDegree))*20)
			UiImage("ui/hud/target.png")
			UiImage("ui/hud/crosshair-gun.png")
		UiPop()
	end
end